///////////////////////////////////////////////////////////////////////////////
//
// GameAppDoc.h
//
///////////////////////////////////////////////////////////////////////////////
#ifndef GAMEAPPDOC_H
#define GAMEAPPDOC_H

#include <eikdoc.h>
#include "GameModel.h"
#include "GameHighScoreTable.h"

class CCoeEnv;
const TInt KMaxNumScores = 5;

///////////////////////////////////////////////////////////////////////////////
// CGameDocument
///////////////////////////////////////////////////////////////////////////////
class CGameDocument : public CEikDocument
	{
public:
	CGameDocument(CEikApplication& aApp, CCoeEnv& aEnv);
	virtual ~CGameDocument();
	void ConstructL();
	void NewGameL();
	void NewL(TInt aResourceId, const TDesC& aFileName);
	void OpenL(const TDesC& aFileName);
	void LevelPathL(TFileName& aFileName) const;
public:
	inline CGameModel& Model()             { return *iModel; }
	inline const CGameModel& Model() const { return *iModel; }
public:
	void LoadHighScoresL();
	void SaveHighScoresL();
public:
	virtual CEikAppUi* CreateAppUiL();
	virtual void NewDocumentL();
	virtual void SaveL();
	virtual void StoreL(CStreamStore& aStore, CStreamDictionary& aStreamDic) const;
	virtual void RestoreL(const CStreamStore& aStore, const CStreamDictionary& aStreamDic);
private:
	CStreamDictionary* ReadStoreDictionaryLC(CFileStore& aStore);
	void ChangeFile(const TDesC& aFileName, CFileStore* aStore);
	void UpdateState(TBool aChanged);
	CGameHighScoreTable* ReadHighScoresStreamL(CDictionaryStore&);
private:
	CCoeEnv& iEnv;
	TFileName iFileName;
	CGameModel* iModel;
	};

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
#endif
