///////////////////////////////////////////////////////////////////////////////
//
// GameAppView.h
//
///////////////////////////////////////////////////////////////////////////////
#ifndef GAMEAPPVIEW_H
#define GAMEAPPVIEW_H

#include <eikbctrl.h>
#include "GameModelObserver.h"

class CEikHotKeyTable;
class CGameDocument;
class CScreenTextBox;

///////////////////////////////////////////////////////////////////////////////
// CGameAppView
///////////////////////////////////////////////////////////////////////////////
class CGameAppView : public CEikBorderedControl, public MGameModelPlayerInput
	{
public:
	CGameAppView(CGameDocument&);
	virtual ~CGameAppView();
	void ConstructL(const TRect& aRect);
	void RedrawScreen();
	void ScreenRect(TRect& aRect) const;
	TChar GetKeyChar();

public:
	virtual TKeyResponse OfferKeyEventL(const TKeyEvent& aKeyEvent,TEventCode aType);
	virtual TSize MinimumSize();
	virtual TGameMessage::TAddress PlayerAddressL(CGameModel&);
	void ResetPlayerAddress() { iPlayerAddress = TGameMessage::KNullAddress; }
	virtual void GetPlayerInput(CGameModel&, MGameModelPlayerInput::TPlayerKeyState&);
	virtual void ResetPlayerInput(CGameModel&);
protected:
	virtual void SizeChangedL();
private:
	virtual void Draw(const TRect& aRect) const;

private:
	enum TPlayerCommand
		{
		ECmdThrust = 10,
		ECmdStop,
		ECmdTurnLeft,
		ECmdTurnRight,
		ECmdShoot
		};
private:
	CGameDocument& iDoc;
	TPoint iScreenPos;
	CEikHotKeyTable* iPlayerKeys;
	TGameMessage::TAddress iPlayerAddress;
	MGameModelPlayerInput::TPlayerKeyState iKeyUp;
	MGameModelPlayerInput::TPlayerKeyState iKeyDown;
	TChar iKeyChar;
	};

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
#endif