///////////////////////////////////////////////////////////////////////////////
//
// GameFactory.h
//
// Static factory for all polymorphic game objects;
//  sprites, states, and objects.
//
///////////////////////////////////////////////////////////////////////////////
#ifndef GAMEFACTORY_H
#define GAMEFACTORY_H

#include <e32std.h>
class TResourceReader;
class RReadStream;
class RWriteStream;
class MGameStreamable;
class CGameObjectController;

///////////////////////////////////////////////////////////////////////////////
// GameFactory
///////////////////////////////////////////////////////////////////////////////
class GameFactory
	{
public:
	static void ReadGameTypeL(TResourceReader&, TUidType&);
	static void ReadGameTypeL(RReadStream&, TUidType&);
	static void WriteGameTypeL(RWriteStream&, const TUidType&);
public:
	static MGameStreamable* NewByTypeLC(const TUidType&, CGameObjectController&);
public:
	static MGameStreamable* NewSpriteByTypeLC(const TUidType&);
	static MGameStreamable* NewObjectByTypeLC(const TUidType&, CGameObjectController&);
	static MGameStreamable* NewObjectStateByTypeLC(const TUidType&, CGameObjectController&);
	};

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
#endif
