///////////////////////////////////////////////////////////////////////////////
//
// MineState.h
//
//
///////////////////////////////////////////////////////////////////////////////
#ifndef MINESTATE_H
#define MINESTATE_H

#include "ObjectStates.h"


///////////////////////////////////////////////////////////////////////////////
// CGameObjectMineState
///////////////////////////////////////////////////////////////////////////////
class CGameObjectMineState : public CGameObjectMotiveSolidState, public MMotionBounds
	{
public:
	CGameObjectMineState(CGameObjectController& aController);
	virtual TUidType Type() const;
	virtual void InternalizeL(TResourceReader&);
	virtual void InternalizeL(RReadStream&);
	virtual void ExternalizeL(RWriteStream&) const;
	virtual void Adjust(TCoOrds& aPosition, const TTrigXY& aDimensions, TMotionPhysics&);
protected:
	virtual TGameMessage::TResponse OnEnterL(const TGameMessage&);
	virtual TGameMessage::TResponse OnUpdateL(const TGameMessage&);
	virtual void AdjustXOutOfBounds(TTrigUnit&, TTrigUnit aWidth, MMotionBounds::TOutOfBounds, TMotionPhysics&);
	virtual void AdjustYOutOfBounds(TTrigUnit&, TTrigUnit aHeight, MMotionBounds::TOutOfBounds, TMotionPhysics&);
	void SeekTargetL(CGameObject& aMine);
private:
	TTrigUnit iRange;
	TTrigUnit iSpeed;
	TInt16 iTargetAllegience;
	};

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////



///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
#endif
