///////////////////////////////////////////////////////////////////////////////
//
// SpriteParticle.h
//
//
// Particle sprite classes.
//
//
///////////////////////////////////////////////////////////////////////////////
#ifndef SPRITEPARTICLE_H
#define SPRITEPARTICLE_H

#include "SpriteTable.h"
#include "ScreenColor.h"
#include <gdi.h>


///////////////////////////////////////////////////////////////////////////////
// CGameParticleSprite
///////////////////////////////////////////////////////////////////////////////
class CGameParticleSprite : public CBase, public MGameSpriteObject
	{
public:
	inline CGameParticleSprite() {}
	CGameParticleSprite(TRgb aColor);
	void SetFrames(const TFadedColor&);

	virtual TUidType Type() const;
	virtual void InternalizeL(TResourceReader&);
	virtual void InternalizeL(RReadStream&);
	virtual void ExternalizeL(RWriteStream&) const;
	virtual void SetId(TInt32);
	virtual TInt FrameCount(CGameSpriteData* aSpriteData) const;
	virtual TSize FrameSize(TInt aFrame, CGameSpriteData* aSpriteData) const;
	virtual void DrawFrame(TInt aFrame, CBitmapContext& aGc, const TPoint& aPos, CGameSpriteData* aSpriteData, MMotionBounds* aBounds) const;
protected:
	TFadedColor iColorFrames;
	};

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
#endif
