///////////////////////////////////////////////////////////////////////////////
//
// SpritePolygon.h
//
//
// Polygon sprite classes.
//
//
///////////////////////////////////////////////////////////////////////////////
#ifndef SPRITEPOLYGON_H
#define SPRITEPOLYGON_H

#include "SpriteTable.h"
#include "ScreenColor.h"
#include <gdi.h>


///////////////////////////////////////////////////////////////////////////////
// CGamePolygonSprite
///////////////////////////////////////////////////////////////////////////////
class CGamePolygonSprite : public CBase, public MGameSpriteObject
	{
public:
	CGamePolygonSprite();
	void SetLineStyle(CGraphicsContext::TPenStyle aLineStyle);
	virtual TUidType Type() const;
	virtual void InternalizeL(TResourceReader&);
	virtual void InternalizeL(RReadStream&);
	virtual void ExternalizeL(RWriteStream&) const;
	virtual void SetId(TInt32);
	virtual TInt FrameCount(CGameSpriteData* aSpriteData) const;
	virtual TSize FrameSize(TInt aFrame, CGameSpriteData* aSpriteData) const;
	virtual void DrawFrame(TInt aFrame, CBitmapContext& aGc, const TPoint& aPos, CGameSpriteData* aSpriteData, MMotionBounds* aBounds) const;
private:
	CGraphicsContext::TPenStyle iLineStyle;
	TFadedColor iDefaultLineColor;
	};

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
#endif
