///////////////////////////////////////////////////////////////////////////////
//
// Physics.inl
//
//
//
//
//
///////////////////////////////////////////////////////////////////////////////
#ifndef PHYSICS_INL
#define PHYSICS_INL


///////////////////////////////////////////////////////////////////////////////
// TVector
///////////////////////////////////////////////////////////////////////////////
inline TVector::TVector()
	{
	}

///////////////////////////////////////////////////////////////////////////////
inline TVector::TVector(const TTrigUnit& aX, const TTrigUnit& aY)
: TTrigXY(aX, aY)
	{
	}

///////////////////////////////////////////////////////////////////////////////
inline TVector::TVector(const TTrigXY& aSrc)
: TTrigXY(aSrc)
	{
	}

///////////////////////////////////////////////////////////////////////////////
inline TVector& TVector::operator= (const TVector& aSrc)
	{
	TTrigXY::operator=(aSrc);
	return *this;
	}

///////////////////////////////////////////////////////////////////////////////
inline TVector& TVector::operator+=(const TVector& aSrc)
	{
	TTrigXY::operator+=(aSrc);
	return *this;
	}

///////////////////////////////////////////////////////////////////////////////
inline TVector& TVector::operator-=(const TVector& aSrc)
	{
	TTrigXY::operator-=(aSrc);
	return *this;
	}

///////////////////////////////////////////////////////////////////////////////
inline TVector& TVector::operator*=(const TVector& aSrc)
	{
	TTrigXY::operator*=(aSrc);
	return *this;
	}

///////////////////////////////////////////////////////////////////////////////
inline TVector& TVector::operator/=(const TVector& aSrc)
	{
	TTrigXY::operator/=(aSrc);
	return *this;
	}

///////////////////////////////////////////////////////////////////////////////
inline TVector& TVector::operator%=(const TVector& aSrc)
	{
	TTrigXY::operator%=(aSrc);
	return *this;
	}

///////////////////////////////////////////////////////////////////////////////
inline TVector& TVector::operator= (const TTrigUnit& aSrc)
	{
	TTrigXY::operator= (aSrc);
	return *this;
	}

///////////////////////////////////////////////////////////////////////////////
inline TVector& TVector::operator+=(const TTrigUnit& aSrc)
	{
	TTrigXY::operator+=(aSrc);
	return *this;
	}

///////////////////////////////////////////////////////////////////////////////
inline TVector& TVector::operator-=(const TTrigUnit& aSrc)
	{
	TTrigXY::operator-=(aSrc);
	return *this;
	}

///////////////////////////////////////////////////////////////////////////////
inline TVector& TVector::operator*=(const TTrigUnit& aSrc)
	{
	TTrigXY::operator*=(aSrc);
	return *this;
	}

///////////////////////////////////////////////////////////////////////////////
inline TVector& TVector::operator/=(const TTrigUnit& aSrc)
	{
	TTrigXY::operator/=(aSrc);
	return *this;
	}

///////////////////////////////////////////////////////////////////////////////
inline TVector& TVector::operator%=(const TTrigUnit& aSrc)
	{
	TTrigXY::operator%=(aSrc);
	return *this;
	}

///////////////////////////////////////////////////////////////////////////////
inline TVector TVector::operator+(const TVector& aSrc) const
	{
	TVector r(*this);
	r += aSrc;
	return r;
	}

///////////////////////////////////////////////////////////////////////////////
inline TVector TVector::operator-(const TVector& aSrc) const
	{
	TVector r(*this);
	r -= aSrc;
	return r;
	}

///////////////////////////////////////////////////////////////////////////////
inline TVector TVector::operator*(const TVector& aSrc) const
	{
	TVector r(*this);
	r *= aSrc;
	return r;
	}

///////////////////////////////////////////////////////////////////////////////
inline TVector TVector::operator/(const TVector& aSrc) const
	{
	TVector r(*this);
	r /= aSrc;
	return r;
	}

///////////////////////////////////////////////////////////////////////////////
inline TVector TVector::operator%(const TVector& aSrc) const
	{
	TVector r(*this);
	r %= aSrc;
	return r;
	}

///////////////////////////////////////////////////////////////////////////////
inline TVector TVector::operator+(const TTrigUnit& aSrc) const
	{
	TVector r(*this);
	r += aSrc;
	return r;
	}

///////////////////////////////////////////////////////////////////////////////
inline TVector TVector::operator-(const TTrigUnit& aSrc) const
	{
	TVector r(*this);
	r -= aSrc;
	return r;
	}

///////////////////////////////////////////////////////////////////////////////
inline TVector TVector::operator*(const TTrigUnit& aSrc) const
	{
	TVector r(*this);
	r *= aSrc;
	return r;
	}

///////////////////////////////////////////////////////////////////////////////
inline TVector TVector::operator/(const TTrigUnit& aSrc) const
	{
	TVector r(*this);
	r /= aSrc;
	return r;
	}

///////////////////////////////////////////////////////////////////////////////
inline TVector TVector::operator%(const TTrigUnit& aSrc) const
	{
	TVector r(*this);
	r %= aSrc;
	return r;
	}

///////////////////////////////////////////////////////////////////////////////
inline void TVector::Set(const TTrigUnit& aX, const TTrigUnit& aY)
	{
	TTrigXY::Set(aX, aY);
	}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
#endif